package com.atguigu.java.javaconfig;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.serializer.GenericJackson2JsonRedisSerializer;
import org.springframework.data.redis.serializer.RedisSerializer;

@Configuration
public class RedisConfigration {
    @Bean
    public RedisTemplate<String,Object> redisTemplate(RedisConnectionFactory redisConnectionFactory){

        //创建一个对象
        RedisTemplate<String,Object> redisTemplate = new RedisTemplate<>();

        //与库连接上的关键数据
        redisTemplate.setConnectionFactory(redisConnectionFactory);
        //String类型的序列化器
        RedisSerializer<String> stringSerializer = RedisSerializer.string();
        //json类型的序列化器
        GenericJackson2JsonRedisSerializer genericJackson2JsonRedisSerializer
                = new GenericJackson2JsonRedisSerializer();

//        设置序列化器

        redisTemplate.setKeySerializer(stringSerializer);
        redisTemplate.setValueSerializer(genericJackson2JsonRedisSerializer);
        redisTemplate.setHashKeySerializer(stringSerializer);
        redisTemplate.setHashValueSerializer(genericJackson2JsonRedisSerializer);

        //返回数据
        return redisTemplate;
    }
}
