package com.atguigu.java.javaconfig;

import com.atguigu.java.interceptors.AllInterceptor;
import org.springframework.cglib.transform.impl.AddInitTransformer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * projectName: com.atguigu.java
 *
 * @author: 赵伟风
 * description: 目标；将拦截器加入到ioc容器的同时还要设置拦截和放行地址！
 *    1. 配置类添加@Configuration注解
 *    2. springmvc的配置类需要使用特殊的接口WebMvcConfigurer
 *    3. WebMvcConfigurer接口中提供各种方法配置特殊（拦截器）的组件对象
 *    4. 重写addInterceptor方法
 *    5. 方法的形参对象 InterceptorRegistry 拦截器加入到ioc容器和配置拦截和放行的地址
 */
@Configuration
public class SpringMvcConfiguration implements WebMvcConfigurer {

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(new AllInterceptor()).addPathPatterns("/**").excludePathPatterns("/user/a").order(10);
    }
}
